#include <stdio.h>
#include <stdlib.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <errno.h>
#include <string.h>

#define SHM_SIZE    10
#define SHM_MODE    (SHM_R | SHM_W | IPC_CREAT)  /* read/write */

int main(void) {
    int shmid;
    char *ptr, *shmptr;
    key_t mykey;
    
    printf("%s\n%s\n",
	   "I should run first. I create shared memory and write *",
	   "all over it");
    
    if ((mykey =  ftok("/home/reverbel/Cursos/mac438", 1)) == -1) {
	printf("Error in ftok: %s\n", strerror(errno));
	exit(1);
    }
    printf("mykey is %d\n", mykey);
    if(( shmid = shmget(mykey , SHM_SIZE, SHM_MODE)) < 0) {
	printf("Error in shmget: %s\n", strerror(errno));
	exit(1);
    }
    
    if (( shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
	printf("Can't attach shared memory\n");
    }
    
    printf("shared memory attached from %p to %p\n",
	   shmptr, shmptr+SHM_SIZE);
    
    
    ptr = shmptr;
    while (ptr < shmptr + SHM_SIZE) {
	*ptr = '*';
	ptr++;
    }
    ptr = shmptr;
    printf("After writing the memory has: ");
    while (ptr < shmptr + SHM_SIZE) {
	printf("%c",*ptr);
	ptr++;
    }
    printf("\n");
    
    if (shmdt(shmptr) <  0) {
	printf("Can't detach shared memory\n");
    }
    
    exit(0);
}
